DECLARE SUB Demo ()
DECLARE SUB ShowInfo (FirstCall AS INTEGER)
DECLARE FUNCTION StringInput$ (Message AS STRING, StrLength AS INTEGER, YRow AS INTEGER, XColumn AS INTEGER)
DECLARE SUB OpenFile (FileName$, SL AS STRING)
DECLARE FUNCTION Intellect% (XBox AS INTEGER, XLength AS INTEGER, BoxDX AS INTEGER, Pl AS INTEGER)
DECLARE SUB RestoreScreen (FirstCall AS INTEGER)
DECLARE SUB Pause (Seconds!)
DECLARE SUB NewWindow (XUp AS INTEGER, NumSymb AS INTEGER, LongSymb AS INTEGER, Help AS INTEGER, F AS INTEGER)
DECLARE SUB FileMenu (FirstCall AS INTEGER)
DECLARE SUB DBox (Urow%, Ucol%, Lrow%, Lcol%)
DECLARE SUB SendBackTest ()
DECLARE SUB ShowSprites (Xx AS INTEGER, yy AS INTEGER, First AS INTEGER, ClearScreen AS INTEGER)
DECLARE SUB Tiebreak (Pl AS INTEGER)
DECLARE SUB GameOver (PlWon AS INTEGER)
DECLARE SUB NewSet (Num AS INTEGER)
DECLARE FUNCTION SpeedDXDY% (Direction AS INTEGER)
DECLARE SUB NextGame (Pl AS INTEGER)
DECLARE SUB ResetSpeeds ()
DECLARE SUB ChangeCount (Player AS INTEGER)
DECLARE SUB NewServe (XBox AS INTEGER, YBox AS INTEGER, XLength AS INTEGER, DYBox AS INTEGER)
'====================Tennis===================
'|         Programmed by Mark Polyak         |
'|                                           |
'=============================================
'D = L; T = R (for help, just incase)
'0 = Down; 1 = Top


CLS

'  Boolean constants
CONST TRUE = -1, FALSE = 0
'  Mathematic constants
CONST PI = 3.141592653589793#
'  File names
CONST TMPFILE$ = "$$$87y$.$5$"       ' Unlikely file name
'  Game field constants
CONST TOP = 0, DOWN = 479, LEFT = 100, RIGHT = 530 '?; ?; 30; 600
'  Sprite arrays
CONST BALLSPR = 700, PLAYERSPR = 600 '5000; 14000
'  Constants for extended ASCII graphic characters.
CONST ULEFTC = 201, URIGHTC = 187, VERTICAL = 186, HORIZONTAL = 205
CONST LLEFTC = 200, LRIGHTC = 188
CONST CURSOR = "_" '""  ""

TYPE Player
    FIO AS STRING * 12
    clr AS INTEGER
END TYPE
DIM PlayerTop AS Player, PlayerDown AS Player

TYPE IntellectErr
    OnOff AS INTEGER
    EndTime AS SINGLE
    Probability AS SINGLE
    FindTheBallSpeed AS INTEGER
END TYPE
DIM IntelError(1) AS IntellectErr, MakeIntelError AS INTEGER

DIM RunMode AS STRING, GameDifficulty AS STRING
DIM x AS INTEGER, y AS INTEGER, r AS INTEGER, d AS INTEGER
DIM dx AS INTEGER, dy AS INTEGER
DIM BallSprite(BALLSPR) AS INTEGER
DIM PlTopSprite(PLAYERSPR) AS INTEGER, PlDownSprite(PLAYERSPR) AS INTEGER
DIM XBoxDown AS INTEGER, XBoxTop AS INTEGER, YBoxDown AS INTEGER, YBoxTop AS INTEGER
DIM YWide AS INTEGER, XDown AS INTEGER, XTop AS INTEGER
DIM DXStep AS INTEGER
DIM DXBoxDown AS INTEGER, DXBoxTop AS INTEGER
DIM n AS SINGLE, ServePlace AS INTEGER, StartTime AS DOUBLE, PlayTime AS DOUBLE
DIM Server AS INTEGER
DIM DCountGame AS INTEGER, TCountGame AS INTEGER, Rules AS INTEGER
DIM GameD(0 TO 5) AS INTEGER, GameT(0 TO 5) AS INTEGER
DIM CircleCoordinates(1, 1 TO 9) AS INTEGER '(0, ...) - X; (1, ...) - Y
'CircleCoordinates( . ,1 to 9) -- ( . , 1) = ( . , 9)
DIM SetD AS INTEGER, SetT AS INTEGER, CurrentSet AS INTEGER
DIM CountD AS INTEGER, CountT AS INTEGER, CheckForTieBreak AS INTEGER
DIM WD AS INTEGER, WT AS INTEGER
DIM zzzz AS INTEGER
'FileMenu variables:
DIM a(500) AS INTEGER, bb(1000) AS INTEGER
DIM XCursor(5) AS INTEGER, CurrentWindow AS INTEGER
'$DYNAMIC
DIM YCursor(10) AS INTEGER
DIM LoadGameFile AS STRING

Demo

SCREEN 12 '640*480
RANDOMIZE TIMER
'OpenFile "new", "SaveGame"

'Set deafult option variables
OpenFile "tendef.ini", "LoadSettings"

'Define Alt + Q for Exit Program
KEY 15, CHR$(&H68) + CHR$(&H10) 'CapsLock + NumLock + Alt + Q
KEY 16, CHR$(&H8) + CHR$(&H10) 'Alt + Q
KEY 17, CHR$(&H48) + CHR$(&H10) 'CapsLock + Alt + Q
KEY 18, CHR$(&H28) + CHR$(&H10) 'NumLock + Alt + Q
ON KEY(15) GOSUB KeyAltQ
ON KEY(16) GOSUB KeyAltQ
ON KEY(17) GOSUB KeyAltQ
ON KEY(18) GOSUB KeyAltQ
KEY(0) ON

'Load sprites
OpenFile "Ten.spr", "LoadSprites"

FileMenu -1 'Get user options


x = 320: y = 240 '334 :240
r = 12: d = 2 * r
n = 0
YWide = 10: XDown = 50: YBoxDown = DOWN - YWide - 2: XBoxDown = LEFT + (RIGHT - LEFT - XDown) / 2
YBoxTop = TOP + 2: YWide = 10: XTop = 50: XBoxTop = LEFT + (RIGHT - LEFT - XTop) / 2
PlayerTop.clr = 3: PlayerDown.clr = 2
StartTime = TIMER: PlayTime = TIMER - StartTime

Server = INT(RND * 2) ': GameD(0) = 0: GameT(0) = 0
CheckForTieBreak = 0
DXBoxDown = SpeedDXDY(2): DXBoxTop = SpeedDXDY(2)

IF Server = 0 THEN
    NewServe XBoxDown, YBoxDown, XDown, DXBoxDown
ELSEIF Server = 1 THEN
    NewServe XBoxTop, YBoxTop, XTop, DXBoxTop
END IF
IF LoadGameFile <> "" THEN
    OpenFile LoadGameFile, "LoadGame"
END IF

CLS
LINE (LEFT, 0)-(LEFT, 480), 10   'Side
LINE (RIGHT, 0)-(RIGHT, 480), 10 'lines
PAINT (320, 240), 6, 10

ShowInfo TRUE
ShowSprites x, y, -1, 0



DO 'start of the main loop

    ss$ = INKEY$
    IF ss$ <> "" THEN 'check if a key is pressed
        IF ss$ = CHR$(27) THEN 'Escape
            OpenFile "Autosave", "SaveGame" 'Save the current game
            BeginWaitTime = TIMER 'while player is in Main Menu, the match time stops
            FileMenu 0
            StartTime = StartTime + TIMER - BeginWaitTime
            IF RunMode = "Watch" THEN
                IntelError(0).Probability = 1
                IntelError(1).Probability = 1
            END IF
        ELSEIF ss$ = " " THEN 'Spacebar
            BeginWaitTime = TIMER 'while the game is on pause, the match time stops
            SLEEP
            StartTime = StartTime + TIMER - BeginWaitTime
        ELSEIF ss$ = CHR$(96) THEN 'cheat code (`(~))
            LOCATE 14, 1
            INPUT zzzz
            ChangeCount zzzz
            LINE (0, 200)-(100, 250), 0, BF
        ELSEIF ss$ = CHR$(9) THEN 'Tab
            ShowInfo -1
        ELSEIF MID$(ss$, 2, 1) = "M" THEN 'ࠢ
            IF RunMode = "Play" OR RunMode = "Play2" THEN
                XBoxDown = XBoxDown + DXStep 'ABS(DXBoxDown)
            END IF
        ELSEIF MID$(ss$, 2, 1) = "K" THEN '
            IF RunMode = "Play" OR RunMode = "Play2" THEN XBoxDown = XBoxDown - DXStep'ABS(DXBoxDown)
        ELSEIF ss$ = CHR$(65) OR ss$ = CHR$(97) THEN 'A or a
            IF RunMode = "Play2" THEN XBoxTop = XBoxTop - DXStep
        ELSEIF ss$ = "d" OR ss$ = "D" THEN
            IF RunMode = "Play2" THEN XBoxTop = XBoxTop + DXStep
        END IF
        
    END IF 'end check "if key is pressed"
   
    'KEY(15) ON
    'KEY(12) ON
    'KEY(13) ON

    IF nn! >= 1 THEN  '8 = .1875 (.19)
    IF y >= DOWN - d THEN
        SOUND 200, 2
        
        IF CheckForTieBreak = 0 THEN
            ChangeCount 1
        ELSE
            'tiebreak
            Tiebreak 1
        END IF
       
        IF Server = 0 THEN
            NewServe XBoxDown, YBoxDown, XDown, DXBoxDown
        ELSEIF Server = 1 THEN
            NewServe XBoxTop, YBoxTop, XTop, DXBoxTop
        END IF
    ELSEIF y <= TOP THEN
        SOUND 200, 2
        IF CheckForTieBreak = 0 THEN
            ChangeCount 0
        ELSE
            'tiebreak
            Tiebreak 0
        END IF
       
        IF Server = 0 THEN
            NewServe XBoxDown, YBoxDown, XDown, DXBoxDown
        ELSEIF Server = 1 THEN
            NewServe XBoxTop, YBoxTop, XTop, DXBoxTop
        END IF
    END IF
   
    IF dx = 0 THEN
        n = n + 1
    END IF
    IF n > 24.26666 THEN
        ResetSpeeds
        n = 0
    END IF
       
        'LINE (260, 200)-(350, 320), 0, BF
        x = x + dx
        y = y + dy
        'XBoxTop = XBoxTop + DXBoxTop
        IF RunMode = "Watch" THEN
            DXBoxTop = Intellect%(XBoxTop, XTop, DXBoxTop, 1)
            DXBoxDown = Intellect%(XBoxDown, XDown, DXBoxDown, 0)
            XBoxTop = XBoxTop + DXBoxTop
            XBoxDown = XBoxDown + DXBoxDown
        ELSEIF RunMode = "Play" THEN
            DXBoxTop = Intellect%(XBoxTop, XTop, DXBoxTop, 1)
            'LOCATE 19, 1: PRINT DXBoxTop
            XBoxTop = XBoxTop + DXBoxTop
        END IF
       
        u = 1
        FOR I = 0 TO 2 * PI STEP PI / 4
            CircleCoordinates(0, u) = r * COS(I) + x + r 'x
            CircleCoordinates(1, u) = r * SIN(I) + y + r 'y
            'for help look at the bottom of the main module (look down the program)

            u = u + 1
        NEXT I

        SendBackTest

        IF XBoxTop < LEFT THEN 'done
            XBoxTop = LEFT + 1
            DXBoxTop = -DXBoxTop
        ELSEIF XBoxTop + XTop > RIGHT THEN
            XBoxTop = RIGHT - XTop - 1
            DXBoxTop = -DXBoxTop
        END IF
        IF XBoxDown < LEFT THEN 'done
            XBoxDown = LEFT + 1
            DXBoxDown = -DXBoxDown
        ELSEIF XBoxDown + XDown > RIGHT THEN
            XBoxDown = RIGHT - XDown - 1
            DXBoxDown = -DXBoxDown
        END IF

        nn! = 0
        
    END IF

    ON ERROR GOTO ErrorHandler
   
    ShowSprites x, y, 0, 0
   
    LINE (LEFT, 0)-(LEFT, 480), 10   'Side
    LINE (RIGHT, 0)-(RIGHT, 480), 10 'lines
   
    LINE (LEFT, TOP)-(RIGHT, TOP), 4   'Top & bottom
    LINE (LEFT, DOWN)-(RIGHT, DOWN), 4 'red lines
    'Lines, marking the serving place:
    LINE (LEFT + (RIGHT - LEFT) / 2, TOP)-(LEFT + (RIGHT - LEFT) / 2, TOP + 5), 3
    LINE (LEFT + (RIGHT - LEFT) / 2, DOWN)-(LEFT + (RIGHT - LEFT) / 2, DOWN - 5), 3

   
    'SLEEP 1
    Pause (.02) '.055
    'SOUND 32000, 1  ' 1 .75 .303333  .1875  .375  .75  1.5
    nn! = nn! + 1
    ShowInfo 0
    
LOOP 'end of the main loop
END

XBoxDown = 0: YBoxDown = 100: XLeft = 60: XDown = 100
XBoxTop = 580: YBoxTop = 100: XRight = 60: XTop = 100

DXBoxDown = 5: DXBoxTop = 5

'CircleCoordinates(0, z ) = x; CircleCoordinates(1, z ) = y
'             z = 7
'           __.__
'   z = 6 ./     \.z = 8
'        /         \
'z = 5 .|           |.z = 1
'       |           |
'        \.       ./z = 2
'    z = 4 \__.__/
'             z = 3
'
FOR I = 0 TO 2 * PI STEP PI / 4
    u = u + 1
    
    CircleCoordinates(0, u) = r * COS(I) + X1 + r 'x
    CircleCoordinates(1, u) = r * SIN(I) + Y1 + r 'y

    'PSET (x2, y2), 4
NEXT I

ErrorHandler:
  BEEP
  OpenFile "Error.tn", "SaveErrorInf"
  CLS
  LOCATE 12, 30
  SELECT CASE ERR
    CASE 64, 53
        'Bad File Name or File Not Found
        RestoreScreen 0
       
        z = INT((80 - 11 - 8) / 2)
        LINE (z * 8 - 64, 184)-((z + 22) * 8 + 30, 264), 14, BF
        LOCATE 13, 37:  PRINT "ERROR"
        LOCATE 14, 24: PRINT " Bad file name / File not found "
        LOCATE 15, 24: PRINT "The Autosave file will be loaded"
        LOCATE 16, 24: PRINT "      Press Esc to continue     "
        WHILE INKEY$ <> CHR$(27): WEND
       
        FileName$ = "saves\" + "Autosave" + ".sav"
        OPEN FileName$ FOR INPUT AS #1
        RESUME NEXT

  END SELECT
  LOCATE 1, 1: PRINT "ERROR"; ERR; "Erdev"; ERDEV; "Erdev$"; ERDEV$
  SLEEP
  END

KeyAltQ:
  OpenFile "tendef.ini", "SaveSettings"
  END

KeyLeftArrow: '
  XBoxDown = XBoxDown - DXStep 'ABS(DXBoxDown)
  RETURN

KeyRightArrow: 'ࠢ
  XBoxDown = XBoxDown + DXStep 'ABS(DXBoxDown)
  RETURN

KeyA:
  XBoxTop = XBoxTop - DXStep
  RETURN

KeyD:
  XBoxTop = XBoxTop + DXStep
  RETURN

REM $STATIC
SUB ChangeCount (Player AS INTEGER) STATIC

SHARED DCountGame AS INTEGER, TCountGame AS INTEGER
SHARED Server AS INTEGER
SHARED GameD() AS INTEGER, GameT() AS INTEGER
SHARED Rules AS INTEGER
SHARED SetD AS INTEGER, SetT AS INTEGER
SHARED CountD AS INTEGER, CountT AS INTEGER

'CountD & CountT - variables, which store and change current play count
'in 0 to 3. Then it is transformed to normal tennis count in
'DCountGame & TCountGame variables - 0, 15, 30, 40.
IF Player = 0 THEN
    CountD = CountD + 1
ELSEIF Player = 1 THEN
    CountT = CountT + 1
ELSEIF Player = 2 THEN
    INPUT CountD, CountT
ELSEIF Player = 3 THEN
    INPUT GameD(0), GameT(0)
END IF

IF CountD = 1 THEN
    DCountGame = 15
ELSEIF CountD = 2 THEN
    DCountGame = 30
ELSEIF CountD = 3 THEN
    DCountGame = 40
ELSEIF CountD > CountT THEN
    DCountGame = 2
ELSEIF CountD = CountT THEN
    DCountGame = 1
    TCountGame = 1
END IF
       
IF CountT = 1 THEN
    TCountGame = 15
ELSEIF CountT = 2 THEN
    TCountGame = 30
ELSEIF CountT = 3 THEN
    TCountGame = 40
ELSEIF CountT > CountD THEN
    TCountGame = 2
END IF

IF CountD > 3 AND CountT < 3 THEN 'new game
    NextGame CountD
ELSEIF CountT > 3 AND CountD < 3 THEN
    NextGame CountT
ELSEIF CountD > 3 AND CountD >= CountT + 2 THEN
    NextGame CountD
ELSEIF CountT > 3 AND CountT >= CountD + 2 THEN
    NextGame CountT
END IF

IF SetD + SetT = 0 THEN
    NewSet 1
ELSEIF SetD + SetT = 1 THEN
    NewSet 2
ELSEIF SetD + SetT = 2 THEN
    NewSet 3
ELSEIF SetD + SetT = 3 THEN
    NewSet 4
ELSEIF SetD + SetT = 4 THEN
    NewSet 5
END IF

IF SetD = Rules THEN 'checking for gameover
    GameOver 0
ELSEIF SetT = Rules THEN
    GameOver 1
END IF

END SUB

DEFINT A-Z
' Subroutine to display boxes.
' Parameters:
'  Urow%, Ucol% : Row and column of upper-left corner.
'  Lrow%, Lcol% : Row and column of lower-right corner.
'  Constants for extended ASCII graphic characters.
'
SUB DBox (Urow%, Ucol%, Lrow%, Lcol%) STATIC
   ' Draw top of box.
   LOCATE Urow%, Ucol%: PRINT CHR$(ULEFTC);
   LOCATE , Ucol% + 1: PRINT STRING$(Lcol% - Ucol%, CHR$(HORIZONTAL));
   LOCATE , Lcol%: PRINT CHR$(URIGHTC);
   ' Draw body of box.
   FOR I = Urow% + 1 TO Lrow% - 1
      LOCATE I, Ucol%: PRINT CHR$(VERTICAL);
      LOCATE , Lcol%: PRINT CHR$(VERTICAL);
   NEXT I
   ' Draw bottom of box.
   LOCATE Lrow%, Ucol%: PRINT CHR$(LLEFTC);
   LOCATE , Ucol% + 1: PRINT STRING$(Lcol% - Ucol%, CHR$(HORIZONTAL));
   LOCATE , Lcol%: PRINT CHR$(LRIGHTC);
END SUB

DEFSNG A-Z
SUB Demo

'CDEFGAB
'music$ = "MB MS O3 L8 E D# L4 E O2 GA O3FE O2G  P24  L8 O3 EE L4G  L8 FEDD O2 AB O3 C "
'PLAY music$
'PLAY "mb ms o3 e e f g g f e d c c d e L3 e L6 d d"
PLAY "mb ms T190 o3 e e f g g f e d c c d e L3 e L6 d d"

SCREEN 8 '2
CLS
VIEW (20, 10)-(620, 190), , 1

CONST PI = 3.141592653589#

WINDOW (-3.15, -.14)-(3.56, 1.01)

' $DYNAMIC
' The rectangle is smaller than the one in the previous
' program, which means Array is also smaller:
WLeft = -.18
WRight = .18
WTop = .05
WBottom = -.05

'ArraySize% = GetArraySize(WLeft, WRight, WTop, WBottom)

DIM Array(1 TO 1000) AS INTEGER

CIRCLE (0, 0), .18, 2
PAINT (0, 0), 2, 2

GET (WLeft, WTop)-(WRight, WBottom), Array
CLS

PAINT (0, .5), 12

'                   LETTER "T"#                                                #             LETTER "E"#                                                                                               #
DRAW "BM95,130  C2 U70 R10 D70 L10 BR5BU35 P2,2 BU35 L35 U5 R70 D5 L35 BU2 P2,2 C1 BD72BR50 U75 R10 D75 L10 BE2P1,1 BG2BR10 R60 U5 L60 BF2 P1,1 BH2BU30 R40 U5 L40 BF2 P1,1 BH2BU30 R60 U5 L60 BF2 P1,1 C3 BH2BD75BR72 "
'     LETTER "N"#                                                                                 #         LETTER "N"#                                                                                 #
DRAW "U75 R10 D75 L10 BE2 P3,3 BG2BR10BU70 F70 U5 H70 BD3BR P3,3 BLBD2BF70 U75 R10 D75 L10 BE2 P3,3 BG2BR22 U75 R10 D75 L10 BE2 P3,3 BG2BR10BU70 F70 U5 H70 BD3BR P3,3 BLBD2BF70 U75 R10 D75 L10 BE2 P3,3 C5 BG2BR22 "
'     LETTER "I"#                                                                                 #    
DRAW "R50 U5 L50 D5 BE2 P5,5 BG2BR20BU5 U65 R10 D65 L10 BE2 P5,5 BG2BU65BL20 U5 R50 D5 L50 BE2 P5,5 C6 BG2BD60BR62"
'     LETTER "S"#                                                                                                                                                    #
DRAW "F10 R50 E10 L10 G5 L40 H5 L10 BR35BD7 P6,6 BU7BR35 U18 TA30 H30 TA0 L10 TA30 F30 TA0 D18 BE2 P6,6 BG2BR10BU38BL72 U17 E10 R50 F10 L10 H5 L40 G5 D17 L10 BE2 P6,6 BG2BD48BR87 "

LOCATE 21, 29
PRINT  '"Programmed by Mark Polyak"  "Press any key to end"

StepSize = .02 '.02
StartLoop = -PI
Decay = 1

DO
   EndLoop = -StartLoop
   FOR X1 = StartLoop TO EndLoop STEP StepSize
      Y1 = ABS(COS(X1)) * Decay - .14

      ' The first PUT statement places the image on
      ' the screen:
      PUT (X1, Y1), Array, XOR

      ' An empty FOR...NEXT loop to delay the program and
      ' reduce image flicker:
      FOR I = 1 TO 500: NEXT I
      'FOR I = 1 TO 200: NEXT I
      'st = TIMER
      'DO: LOOP WHILE st + .000001 > TIMER
      'Delay 0 '.000000000001#

      IF Y1 < -.13 THEN Decay = Decay * .9
      Esc$ = INKEY$
      IF Esc$ <> "" OR Decay < .00001 THEN EXIT DO 'FOR

      ' The second PUT statement erases the image and
      ' restores the background:
      PUT (X1, Y1), Array, XOR
   NEXT X1

   StepSize = -StepSize
   StartLoop = -StartLoop
LOOP UNTIL Esc$ <> "" OR Decay < .00001 OR PLAY(0) <= 1


PLAY "MF"
SLEEP 1

END SUB

REM $STATIC
SUB FileMenu (FirstCall AS INTEGER) 'STATIC

'FileMenu variables
SHARED a() AS INTEGER, bb() AS INTEGER
SHARED XCursor() AS INTEGER, YCursor() AS INTEGER
SHARED CurrentWindow AS INTEGER

'variables that can be changed in this sub
SHARED RunMode AS STRING, GameDifficulty AS STRING
SHARED PlayerTop AS Player, PlayerDown AS Player
SHARED Rules AS INTEGER, IntelError() AS IntellectErr
SHARED LoadGameFile AS STRING, StartTime AS DOUBLE

CLS

RestoreScreen -1

s = 8
YCursor(0) = 16
XCursor(1) = 72
XCursor(2) = XCursor(1) + 96'+ 64 + 32
XCursor(3) = XCursor(2) + 64 + 32
XCursor(4) = XCursor(3) + 104
XCursor(5) = XCursor(4) + 200

XCursor(0) = XCursor(1)
PUT (XCursor(0), YCursor(0)), a
SLEEP 1

DO
    IF CurrentWindow = 0 THEN
        PUT (XCursor(0), YCursor(0)), a, XOR
    ELSE
        PUT (XCursor(0) + 16, YCursor(0)), bb, XOR
    END IF
  
    s$ = INKEY$
    IF s$ <> "" THEN 'check if key is pressed
        IF s$ = CHR$(27) THEN 'Escape
            IF CurrentWindow = 1 THEN
                RestoreScreen 0
            ELSE
                IF NOT FirstCall THEN EXIT DO
            END IF
          
        ELSEIF s$ = CHR$(13) THEN 'Enter
            SELECT CASE XCursor(0)
                CASE XCursor(1)
                    'File (Game) menu
                    IF CurrentWindow = 0 THEN
                        z% = 7
                        REDIM YCursor(z% - 1) AS INTEGER
                        NewWindow XCursor(1), z%, 20, 0, FirstCall
                    ELSEIF CurrentWindow = 1 THEN
                        'Check the first menu window
                        SELECT CASE YCursor(0)
                            CASE YCursor(1)
                                'Run the program
                                RestoreScreen 0
                                EXIT DO
                            CASE YCursor(2)
                                IF NOT FirstCall THEN
                                    'Save the program
                                    RestoreScreen 0
                                    z = (80 - 11 - 8) / 2
                                    LINE (z * 8 - 16, 200)-((z + 22) * 8 + 30, 264), 14, BF
                                    'LOCATE 16, 35: FILES "*.sav"
                                    tmp$ = StringInput$("File Name: ", 8, 15, 34)
                                    IF tmp$ <> "" THEN OpenFile tmp$, "SaveGame"
                                    RestoreScreen -1
                                END IF
                            CASE YCursor(3)
                                'Load the program
                                RestoreScreen 0
                                z = (80 - 11 - 8) / 2
                                LINE (z * 8 - 16, 200)-((z + 22) * 8 + 30, 264), 14, BF
                                tmp$ = StringInput$("File Name: ", 8, 15, 34)
                                IF tmp$ <> "" THEN
                                    IF NOT FirstCall THEN
                                        OpenFile tmp$, "LoadGame"
                                        StartTime = StartTime - 5
                                    ELSE
                                        LoadGameFile = tmp$ 'TRUE
                                    END IF
                                    EXIT DO
                                END IF
                                RestoreScreen -1
                            CASE YCursor(4)
                                'input player top name
                                RestoreScreen 0
                                z = (80 - 18 - 15) / 2
                                LINE (z * 8 - 16, 200)-((z + 34) * 8 + 30, 264), 14, BF
                                tmp$ = StringInput$("Top player name is: ", 12, 15, 25)
                                IF tmp$ <> "" THEN PlayerTop.FIO = tmp$
                                RestoreScreen -1
                            CASE YCursor(5)
                                'input player down name
                                RestoreScreen 0
                                z = (80 - 18 - 15) / 2
                                LINE (z * 8 - 16, 200)-((z + 35) * 8 + 30, 264), 14, BF
                                tmp$ = StringInput$("Down player name is: ", 12, 15, 25)
                                IF tmp$ <> "" THEN PlayerDown.FIO = tmp$
                                RestoreScreen -1
                            CASE YCursor(UBOUND(YCursor, 1))
                                 'Exit the program
                                RestoreScreen 0
                                OpenFile "tendef.ini", "SaveSettings"
                                END
                               
                        END SELECT
                    END IF
                CASE XCursor(2)
                    'Mode menu
                    IF CurrentWindow = 0 THEN
                        z% = 4
                        REDIM YCursor(z% - 1) AS INTEGER
                        NewWindow XCursor(2), z%, 20, 0, FirstCall
                    ELSEIF CurrentWindow = 1 THEN
                        'Check the second menu window
                        SELECT CASE YCursor(0)
                            CASE YCursor(1)
                                'Watch
                                RunMode = "Watch"
                                IntelError(0).Probability = 1
                                IntelError(1).Probability = 1
                                RestoreScreen 0
                            CASE YCursor(2)
                                'Play 1
                                RunMode = "Play"
                                RestoreScreen 0
                            CASE YCursor(3)
                                'Play 2
                                RunMode = "Play2"
                                RestoreScreen 0
                        END SELECT
                    END IF
                CASE XCursor(3)
                    'Level menu
                    IF CurrentWindow = 0 THEN
                        z% = 4
                        REDIM YCursor(z% - 1) AS INTEGER
                        NewWindow XCursor(3), z%, 20, 0, FirstCall
                    ELSEIF CurrentWindow = 1 THEN
                        SELECT CASE YCursor(0)
                            CASE YCursor(1)
                                'Easy
                                'IntelError(0).Probability = 10
                                IntelError(1).Probability = 10
                                GameDifficulty = "Easy"
                                RestoreScreen 0
                            CASE YCursor(2)
                                'Medium
                                IntelError(1).Probability = 4.75
                                GameDifficulty = "Medium"
                                RestoreScreen 0
                            CASE YCursor(3)
                                'Difficult
                                IntelError(1).Probability = .25
                                GameDifficulty = "Difficult"
                                RestoreScreen 0
                        END SELECT
                    END IF
                CASE XCursor(4)
                    'Rules menu
                    IF CurrentWindow = 0 THEN
                        z% = 4
                        REDIM YCursor(z% - 1) AS INTEGER
                        NewWindow XCursor(4), z%, 20, 0, FirstCall
                    ELSEIF CurrentWindow = 1 THEN
                        SELECT CASE YCursor(0)
                            CASE YCursor(1)
                                '1 set match
                                Rules = 1
                                RestoreScreen 0
                            CASE YCursor(2)
                                '2 sets match
                                Rules = 2
                                RestoreScreen 0
                            CASE YCursor(3)
                                '3 sets match
                                Rules = 3
                                RestoreScreen 0
                        END SELECT
                    END IF
                
                CASE XCursor(5)
                    'help
                    NewWindow XCursor(1), 20, 60, -1, FirstCall
            END SELECT
          
        ELSEIF MID$(s$, 2, 1) = "K" THEN '
            IF CurrentWindow = 1 THEN
                RestoreScreen 0
                'CurrentWindow = 0
            END IF
          
            FOR I = 2 TO UBOUND(XCursor, 1)
                IF XCursor(0) = XCursor(I) THEN
                    XCursor(0) = XCursor(I - 1)
                    EXIT FOR
                END IF
                IF XCursor(0) = XCursor(1) THEN
                    XCursor(0) = XCursor(UBOUND(XCursor, 1))
                    EXIT FOR
                END IF
            NEXT I
          
        ELSEIF MID$(s$, 2, 1) = "M" THEN 'ࠢ
            IF CurrentWindow = 1 THEN
                RestoreScreen 0
                'CurrentWindow = 0
            END IF
        
            FOR I = 1 TO UBOUND(XCursor, 1) - 1
                IF XCursor(0) = XCursor(I) THEN
                    XCursor(0) = XCursor(I + 1)
                    EXIT FOR
                END IF
                IF XCursor(0) = XCursor(UBOUND(XCursor, 1)) THEN
                    XCursor(0) = XCursor(1)
                    EXIT FOR
                END IF
            NEXT I
         
        ELSEIF MID$(s$, 2, 1) = "H" THEN '
            IF CurrentWindow = 1 THEN
                FOR I = 2 TO UBOUND(YCursor, 1)
                    IF YCursor(0) = YCursor(I) THEN
                        YCursor(0) = YCursor(I - 1)
                        EXIT FOR
                    END IF
                    IF YCursor(0) = YCursor(1) THEN
                        YCursor(0) = YCursor(UBOUND(YCursor, 1))
                        EXIT FOR
                    END IF
                NEXT I
            END IF
        ELSEIF MID$(s$, 2, 1) = "P" THEN '
            IF CurrentWindow = 1 THEN
                FOR I = 1 TO UBOUND(YCursor, 1) - 1
                    IF YCursor(0) = YCursor(I) THEN
                        YCursor(0) = YCursor(I + 1)
                        EXIT FOR
                    END IF
                    IF YCursor(0) = YCursor(UBOUND(YCursor, 1)) THEN
                        YCursor(0) = YCursor(1)
                        EXIT FOR
                    END IF
                NEXT I
            END IF

        END IF
    END IF
  
    IF CurrentWindow = 0 THEN
        PUT (XCursor(0), YCursor(0)), a
    ELSE
        PUT (XCursor(0) + 16, YCursor(0)), bb
    END IF
  
    'SLEEP
    'SOUND 32000, 1
    'LOCATE 27, 1: PRINT "Player top name: "; RTRIM$(PlayerTop.FIO); "; Player down name: "; RTRIM$(PlayerDown.FIO); "; Mode"; "; Difficulty"; "; Rules: "; Rules; "set(s) match"
    Pause (.04)
LOOP

CLS

IF NOT FirstCall THEN
    LINE (LEFT, 0)-(LEFT, 480), 10   'Side
    LINE (RIGHT, 0)-(RIGHT, 480), 10 'lines
    PAINT (320, 240), 6, 10
    ShowInfo TRUE
    ShowSprites 0, 0, 0, 1
END IF


' Subroutine to display boxes.
' Parameters:
'  Urow%, Ucol% : Row and column of upper-left corner.
'  Lrow%, Lcol% : Row and column of lower-right corner.
'  Constants for extended ASCII graphic characters.

END SUB

SUB GameOver (PlWon AS INTEGER)
DIM WinPlayer AS STRING

SHARED PlayerDown AS Player, PlayerTop AS Player, RunMode AS STRING

ShowInfo 0

IF PlWon = 0 THEN
    tmp$ = LTRIM$(PlayerDown.FIO)
    WinPlayer = RTRIM$(tmp$)
    clr = PlayerDown.clr
ELSEIF PlWon = 1 THEN
    tmp$ = LTRIM$(PlayerTop.FIO)
    WinPlayer = RTRIM$(tmp$)
    clr = PlayerTop.clr
END IF

z = (80 - LEN(WinPlayer) - 17) / 2
LINE (z * 8 - 16, 200)-((z + LEN(WinPlayer) + 17) * 8, 264), 14, BF

LOCATE 15, z '(80 - LEN(WinPlayer) - 22) / 2
COLOR clr: PRINT UCASE$(WinPlayer); " win's the match!"

IF RunMode = "Play" AND PlWon = 1 THEN
    LOCATE 16, z + (LEN(WinPlayer) + 17 - 9) / 2: COLOR 15: PRINT "Game over"
    Music$ = "MFT80o2P4P8L8GGGL2E-P24P8L8FFFL2D"
    PLAY Music$
ELSE
    PLAY "MB mf t170 o3 l3g l4ec o2 a o3 l3f l4d o2 bg o3 L2 ceg"
END IF

'PLAY "mb ms T190 o3 e e f g g f e d c c d e L3 e L6 d d"
'PLAY "mb ms t170 o3 l3g l4ec o2 a o3 l3f l4d o2 bg o3 L2 ceg"
'music$ = "MBT80o2P2P8L8GGGL2E-P24P8L8FFFL2D"
'PLAY music$

COLOR 15
SLEEP

OpenFile "tendef.ini", "SaveSettings"
END

END SUB

FUNCTION Intellect% (XBox AS INTEGER, XLength AS INTEGER, BoxDX AS INTEGER, Pl AS INTEGER)
DIM SpeedBoxDX  AS INTEGER

SHARED x AS INTEGER, y AS INTEGER, r AS INTEGER, d AS INTEGER
SHARED dx AS INTEGER, dy AS INTEGER, DXBoxTop AS INTEGER
SHARED IntelError() AS IntellectErr, MakeIntelError AS INTEGER

IF IntelError(Pl).OnOff = 0 THEN
    IF ((RND < IntelError(Pl).Probability / 100) OR (MakeIntelError = 1)) AND BoxDX = dx THEN '.005
        'cause intellect error
        IntelError(Pl).OnOff = 1
        StartTm! = TIMER
        IntelError(Pl).EndTime = StartTm! + (RND * 1 + 1)
        IntelError(Pl).FindTheBallSpeed = SpeedDXDY(2)
        'LOCATE 18, 1: PRINT "Error"; CurrentTMP
    END IF
ELSE
    IF TIMER > IntelError(Pl).EndTime THEN
        'decause intellect error
        IntelError(Pl).OnOff = 0
        IntelError(Pl).EndTime = 0
        MakeIntelError = 0
        'LOCATE 18, 1: PRINT "        "
    END IF
END IF

IF IntelError(Pl).OnOff = 1 THEN
    'Intellect% = 0
    SpeedBoxDX = 0
    'LOCATE 20, 1: PRINT "int=0   "; IntelError(Pl).FindTheBallSpeed; SpeedBoxDX
ELSEIF (x + r > XBox) AND (x + r < XBox + XLength) THEN
    'Intellect% = dx
    SpeedBoxDX = dx
    'LOCATE 20, 1: PRINT "int=dx  "; IntelError(Pl).FindTheBallSpeed; SpeedBoxDX
ELSE
    IF XBox + XLength <= x + r THEN
        'Intellect% = ABS(CurrentTMP)
        SpeedBoxDX = ABS(IntelError(Pl).FindTheBallSpeed)
        'LOCATE 20, 1: PRINT "int=|C| "; IntelError(Pl).FindTheBallSpeed; SpeedBoxDX
    ELSEIF XBox >= x + r THEN
        'Intellect% = -ABS(CurrentTMP)
        SpeedBoxDX = -ABS(IntelError(Pl).FindTheBallSpeed)
        'LOCATE 20, 1: PRINT "int=-|C|"; IntelError(Pl).FindTheBallSpeed; SpeedBoxDX
    ELSE
        'LOCATE 21, 1: PRINT "x"; x; "y"; y; "r"; r; "XB"; XBoxTop '; "YB"; YBoxTop
    END IF
        
    'Intellect% = ABS(SpeedDXDY(2)) * SGN(dx)
END IF

Intellect% = SpeedBoxDX
END FUNCTION

SUB NewServe (XBox AS INTEGER, YBox AS INTEGER, XLength AS INTEGER, DYBox AS INTEGER)

SHARED x AS INTEGER, y AS INTEGER, r AS INTEGER, dx AS INTEGER, dy AS INTEGER
SHARED YWide AS INTEGER, ServePlace AS INTEGER, n AS SINGLE, DXStep AS INTEGER
SHARED RunMode AS STRING, Server AS INTEGER, XTop AS INTEGER
SHARED WD AS INTEGER, WT AS INTEGER

IF ServePlace = 0 THEN
    XBox = LEFT + (RIGHT - LEFT) / 2 + 1
ELSE
    XBox = LEFT + (RIGHT - LEFT) / 2 - XLength - 1
END IF

IF YBox < 240 THEN
    y = YBox + YWide + 1
ELSE
    y = YBox - 2 * r - 1
END IF

x = XBox + XLength / 2 - r
dx = 0
dy = 0
DYBox = 0
DXStep = 0
n = 0
WD = 0
WT = 0

IF ServePlace = 0 THEN
    ServePlace = 1
ELSEIF ServePlace = 1 THEN
    ServePlace = 0
END IF

END SUB

SUB NewSet (Num AS INTEGER)

SHARED GameD() AS INTEGER, GameT() AS INTEGER
SHARED SetT AS INTEGER, SetD AS INTEGER
SHARED CheckForTieBreak AS INTEGER, CurrentSet AS INTEGER
SHARED DCountGame AS INTEGER, TCountGame AS INTEGER

GameD(Num) = GameD(0)
GameT(Num) = GameT(0)

IF GameD(0) + GameT(0) = 11 THEN
    EXIT SUB
ELSEIF (GameD(5) <> 0) OR (GameT(5) <> 0) THEN
    'Last possible set - play until ABS(GameD(0) - GameT(0)) = 2
    IF (GameD(0) >= 6) AND (GameD(0) - GameT(0) = 2) THEN
        GameOver 0
    ELSEIF (GameT(0) >= 6) AND (GameT(0) - GameD(0) = 2) THEN
        GameOver 1
    END IF
ELSEIF GameD(0) = 6 AND GameT(0) = 6 THEN
    'Tiebreak
    CheckForTieBreak = 1
    Tiebreak 2
    DCountGame = 0
    TCountGame = 0
ELSEIF GameD(0) >= 6 THEN
    SetD = SetD + 1
    GameD(0) = 0
    GameT(0) = 0
ELSEIF GameT(0) >= 6 THEN
    SetT = SetT + 1
    GameD(0) = 0
    GameT(0) = 0
END IF
  
'LINE (255, 218)-(345, 243), 0, BF  '90-25
LINE (7, 218)-(97, 243), 0, BF  '90-25
CurrentSet = Num
   
END SUB

SUB NewWindow (XUp AS INTEGER, NumSymb AS INTEGER, LongSymb AS INTEGER, Help AS INTEGER, F AS INTEGER)

DIM UpColmn AS INTEGER

SHARED XCursor() AS INTEGER, YCursor() AS INTEGER
SHARED CurrentWindow AS INTEGER
SHARED bb() AS INTEGER

CurrentWindow = 1

FOR I = 1 TO UBOUND(YCursor, 1) 'Set the cursor coordinates
    YCursor(I) = I * 16 + 32
NEXT I
YCursor(0) = YCursor(1)

VIEW SCREEN (XUp, 32)-(XUp + LongSymb * 8 + 8, 32 + NumSymb * 16 + 16) ', 1, 1

UpColmn = XUp / 8 + 1
CALL DBox(3, UpColmn, 3 + NumSymb, UpColmn + LongSymb)

IF NOT Help THEN
    IF XUp = XCursor(1) THEN 'File menu
        IF NOT F THEN
            LOCATE 4, UpColmn + 2: COLOR 15: PRINT "Resume"
            LOCATE 5, UpColmn + 2: COLOR 15: PRINT "Save"
        ELSE
            LOCATE 4, UpColmn + 2: COLOR 15: PRINT "Start"
        END IF
        
        LOCATE 6, UpColmn + 2: COLOR 15: PRINT "Load"
        LOCATE 7, UpColmn + 2: COLOR 15: PRINT "Top player Name"
        LOCATE 8, UpColmn + 2: COLOR 15: PRINT "Down player Name"
        LOCATE NumSymb + 2, UpColmn + 2: COLOR 15: PRINT "Exit"
        PAINT (XUp + 10, 100), 1, 15
    ELSEIF XUp = XCursor(2) THEN 'Mode menu
        LOCATE 4, UpColmn + 2: COLOR 15: PRINT "Watch tennis"
        LOCATE 5, UpColmn + 2: COLOR 15: PRINT "Play vs computer"
        LOCATE 6, UpColmn + 2: COLOR 15: PRINT "Play vs friend"
        PAINT (XUp + 10, 100), 1, 15
    ELSEIF XUp = XCursor(3) THEN 'Level menu
        LOCATE 4, UpColmn + 2: COLOR 15: PRINT "Easy"
        LOCATE 5, UpColmn + 2: COLOR 15: PRINT "Medium"
        LOCATE 6, UpColmn + 2: COLOR 15: PRINT "Difficult"
        PAINT (XUp + 10, 100), 1, 15
    ELSEIF XUp = XCursor(4) THEN 'Rules menu
        LOCATE 4, UpColmn + 2: COLOR 15: PRINT "1 Set match"
        LOCATE 5, UpColmn + 2: COLOR 15: PRINT "2 Sets match"
        LOCATE 6, UpColmn + 2: COLOR 15: PRINT "3 Sets match"
        PAINT (XUp + 10, 100), 1, 15
    END IF
ELSE
    'print help
    'LOCATE 5, UpColmn + 27: PRINT "HELP"
    DIM HelpStr(30) AS STRING
   
    OPEN "help.txt" FOR INPUT AS #1
    I = 0
    DO
        LINE INPUT #1, HelpStr(I)
        IF I > 3 THEN LOCATE I, UpColmn + 2: PRINT HelpStr(I)
        I = I + 1
    LOOP WHILE NOT EOF(1)
    CLOSE #1
   
    'LOCATE 4, UpColmn + 1: PRINT tmps$
    CurrentWindow = 0
    YCursor(0) = 16
    PAINT (XUp + 10, 100), 1, 15
    'SLEEP
    DO: LOOP WHILE INKEY$ <> CHR$(27)
    RestoreScreen 0
END IF

END SUB

SUB NextGame (Pl AS INTEGER)

SHARED DCountGame AS INTEGER, TCountGame AS INTEGER
SHARED Server AS INTEGER ', GameL AS INTEGER, GameR AS INTEGER
SHARED CountD AS INTEGER, CountT AS INTEGER
SHARED GameD() AS INTEGER, GameT() AS INTEGER

IF Pl = CountD THEN
    GameD(0) = GameD(0) + 1
ELSEIF Pl = CountT THEN
    GameT(0) = GameT(0) + 1
END IF

IF Server = 0 THEN
    Server = 1
ELSEIF Server = 1 THEN
    Server = 0
END IF

CountD = 0
CountT = 0
DCountGame = 0
TCountGame = 0

END SUB

SUB OpenFile (FileName$, SL AS STRING)

SHARED IntelError() AS IntellectErr
SHARED BallSprite() AS INTEGER
SHARED PlTopSprite() AS INTEGER, PlDownSprite() AS INTEGER
SHARED PlayerTop AS Player, PlayerDown AS Player
SHARED RunMode AS STRING, GameDifficulty AS STRING
SHARED x AS INTEGER, y AS INTEGER, r AS INTEGER, d AS INTEGER
SHARED dx AS INTEGER, dy AS INTEGER
SHARED XBoxDown AS INTEGER, XBoxTop AS INTEGER, YBoxDown AS INTEGER, YBoxTop AS INTEGER
SHARED YWide AS INTEGER, XDown AS INTEGER, XTop AS INTEGER
SHARED DXStep AS INTEGER
SHARED DXBoxDown AS INTEGER, DXBoxTop AS INTEGER
SHARED n AS SINGLE, ServePlace AS INTEGER, StartTime AS DOUBLE, PlayTime AS DOUBLE
SHARED Server AS INTEGER
SHARED DCountGame AS INTEGER, TCountGame AS INTEGER, Rules AS INTEGER
SHARED GameD() AS INTEGER, GameT() AS INTEGER
SHARED SetD AS INTEGER, SetT AS INTEGER, CurrentSet AS INTEGER
SHARED CountD AS INTEGER, CountT AS INTEGER, CheckForTieBreak AS INTEGER
SHARED WD AS INTEGER, WT AS INTEGER
SHARED zzzz AS INTEGER
SHARED a() AS INTEGER, bb() AS INTEGER
SHARED XCursor() AS INTEGER
'$DYNAMIC
SHARED YCursor() AS INTEGER
SHARED CurrentWindow AS INTEGER

'WRITE #1, x, y, r, d, dx, dy, RunMode, GameDifficulty, XBoxDown, XBoxTop, YBoxDown, YBoxTop, YWide, XDown, XTop, DXStep, DXBoxDown, DXBoxTop, n, ServePlace, StartTime, PlayTime, Server, DCountGame
'WRITE #1, TCountGame, Rules, GameD(0), GameT(0), GameD(1), GameT(1), GameD(2), GameT(2), GameD(3), GameT(3), GameD(4), GameT(4), GameD(5), GameT(5), SetD, SetT, CurrentSet, CountD, CountT, CheckForTieBreak

ON ERROR GOTO ErrorHandler

'FileName$ = FileName$ + ".sav" 'InputString + ".sav"
IF SL = "SaveGame" THEN
    'Save the game to specified file
    FileName$ = "saves\" + FileName$ + ".sav"
   
    OPEN TMPFILE$ FOR OUTPUT AS #1
    WRITE #1, ";this file is a save from Tennis game"
    WRITE #1, x, y, r, d, dx, dy, RunMode, GameDifficulty, XBoxDown, XBoxTop, YBoxDown, YBoxTop, YWide, XDown, XTop, DXStep, DXBoxDown, DXBoxTop, n, ServePlace, StartTime, PlayTime, Server, DCountGame
    WRITE #1, TCountGame, Rules, GameD(0), GameT(0), GameD(1), GameT(1), GameD(2), GameT(2), GameD(3), GameT(3), GameD(4), GameT(4), GameD(5), GameT(5), SetD, SetT, CurrentSet, CountD, CountT, CheckForTieBreak
    CLOSE #1
   
    OPEN FileName$ FOR RANDOM AS #2
    CLOSE #2
    KILL FileName$
   
    NAME TMPFILE$ AS FileName$
ELSEIF SL = "LoadGame" THEN
    'Load game from specified file
    FileName$ = "saves\" + FileName$ + ".sav"
   
    OPEN FileName$ FOR INPUT AS #1
    LINE INPUT #1, s$
    INPUT #1, x, y, r, d, dx, dy, RunMode, GameDifficulty, XBoxDown, XBoxTop, YBoxDown, YBoxTop, YWide, XDown, XTop, DXStep, DXBoxDown, DXBoxTop, n, ServePlace, StartTime, PlayTime, Server, DCountGame
    INPUT #1, TCountGame, Rules, GameD(0), GameT(0), GameD(1), GameT(1), GameD(2), GameT(2), GameD(3), GameT(3), GameD(4), GameT(4), GameD(5), GameT(5), SetD, SetT, CurrentSet, CountD, CountT, CheckForTieBreak
    CLOSE #1
    StartTime = TIMER - PlayTime
ELSEIF SL = "SaveSettings" THEN
    'Update the .ini file
    OPEN TMPFILE$ FOR OUTPUT AS #1
    WRITE #1, RunMode, GameDifficulty, Rules, PlayerDown.FIO, PlayerTop.FIO, IntelError(0).Probability, IntelError(1).Probability
    CLOSE #1
   
    OPEN FileName$ FOR RANDOM AS #1
    CLOSE #1
    KILL FileName$

    NAME TMPFILE$ AS FileName$
ELSEIF SL = "LoadSettings" THEN
    'Read the last settings from the .ini file
    OPEN FileName$ FOR INPUT AS #1
    INPUT #1, RunMode, GameDifficulty, Rules, PlayerDown.FIO, PlayerTop.FIO, IntelError(0).Probability, IntelError(1).Probability
    CLOSE #1
ELSEIF SL = "SaveErrorInf" THEN
    'Save the information about an error
    OPEN FileName$ FOR APPEND AS #1
    WRITE #1, DATE$, TIME$, "ERROR", ERR, "Erdev", ERDEV, "Erdev$", ERDEV$, "Erl", ERL
    WRITE #1, x, y, r, d, dx, dy, RunMode, GameDifficulty, XBoxDown, XBoxTop, YBoxDown, YBoxTop, YWide, XDown, XTop, DXStep, DXBoxDown, DXBoxTop, n, ServePlace, StartTime, PlayTime, Server, DCountGame
    WRITE #1, TCountGame, Rules, GameD(0), GameT(0), GameD(1), GameT(1), GameD(2), GameT(2), GameD(3), GameT(3), GameD(4), GameT(4), GameD(5), GameT(5), SetD, SetT, CurrentSet, CountD, CountT, CheckForTieBreak
    CLOSE #1
ELSEIF SL = "LoadSprites" THEN
    'Load ball and players sprites
   
    OPEN FileName$ FOR BINARY AS #1 LEN = LEN(BallSprite(1))
   
    FOR I = 0 TO BALLSPR
        GET #1, , BallSprite(I)
    NEXT I
    FOR I = 0 TO PLAYERSPR
        GET #1, , PlTopSprite(I)
    NEXT I
    FOR I = 0 TO PLAYERSPR
        GET #1, , PlDownSprite(I)
    NEXT I
   
    FOR I = 0 TO 500
        GET #1, , a(I)
    NEXT I
    FOR I = 0 TO 1000
        GET #1, , bb(I)
    NEXT I
    CLOSE #1
END IF

END SUB

REM $STATIC
DEFINT A-Z
'
' =============================== Pause ================================
'   Pause is based on time so that wait will be the same on any processor.
'   Notice the check for negative numbers so that the delay won't
'   freeze at midnight when the delay could become negative.
' ======================================================================
'
SUB Pause (Seconds!) STATIC

    Begin! = TIMER
    DO UNTIL (TIMER - Begin! > Seconds!) OR (TIMER - Begin! < 0)
    LOOP

END SUB

DEFSNG A-Z
SUB ResetSpeeds

SHARED dx AS INTEGER, dy AS INTEGER
SHARED DXBoxDown AS INTEGER, DXBoxTop AS INTEGER, DXStep AS INTEGER

DXBoxDown = SpeedDXDY(2): DXBoxTop = SpeedDXDY(2)
DXStep = 8
'LOCATE 10, 35
'PRINT DXBoxDown; DXBoxTop

DO
    dx = SpeedDXDY(0)
    dy = SpeedDXDY(1)
LOOP UNTIL ABS(dy) > ABS(dx) AND ABS(dy) > 6

END SUB

SUB RestoreScreen (FirstCall AS INTEGER)

SHARED XCursor() AS INTEGER, YCursor() AS INTEGER
SHARED CurrentWindow AS INTEGER

IF NOT FirstCall THEN
    CLS 1
    VIEW
    YCursor(0) = 16
    CurrentWindow = 0
END IF

LINE (0, 39)-(640, 480), 12, BF
CALL DBox(1, 1, 3, 80)
LOCATE 2, 10: COLOR 15: PRINT "File"; SPC(8); "Mode"; SPC(8); "Level"; SPC(8); "Rules"; SPC(20); "Help"
PAINT (10, 10), 1, 15
'                   LETTER "T"#                                                #             LETTER "E"#                                                                                               #
DRAW "BM95,300  C2 U70 R10 D70 L10 BR5BU35 P2,2 BU35 L35 U5 R70 D5 L35 BU2 P2,2 C1 BD72BR50 U75 R10 D75 L10 BE2P1,1 BG2BR10 R60 U5 L60 BF2 P1,1 BH2BU30 R40 U5 L40 BF2 P1,1 BH2BU30 R60 U5 L60 BF2 P1,1 C3 BH2BD75BR72 "
'     LETTER "N"#                                                                                 #         LETTER "N"#                                                                                 #
DRAW "U75 R10 D75 L10 BE2 P3,3 BG2BR10BU70 F70 U5 H70 BD3BR P3,3 BLBD2BF70 U75 R10 D75 L10 BE2 P3,3 BG2BR22 U75 R10 D75 L10 BE2 P3,3 BG2BR10BU70 F70 U5 H70 BD3BR P3,3 BLBD2BF70 U75 R10 D75 L10 BE2 P3,3 C5 BG2BR22 "
'     LETTER "I"#                                                                                 #
DRAW "R50 U5 L50 D5 BE2 P5,5 BG2BR20BU5 U65 R10 D65 L10 BE2 P5,5 BG2BU65BL20 U5 R50 D5 L50 BE2 P5,5 C6 BG2BD60BR62 "
'     LETTER "S"#                                                                                                                                                          #
DRAW "F10 R50 E10 L10 G5 L40 H5 L10 BR35BD7 P6,6 BU7BR35 U18 TA31 H45 TA0 U4 L10 D4 TA31 F45 TA0 D18 BE2 P6,6 BG2BR10BU38BL72 U17 E10 R50 F10 L10 H5 L40 G5 D17 L10 BE2 P6,6 BG2BD48BR87 "

END SUB

SUB SendBackTest STATIC

SHARED CircleCoordinates() AS INTEGER, RunMode AS STRING
SHARED x AS INTEGER, y AS INTEGER, r AS INTEGER, d AS INTEGER
SHARED dx AS INTEGER, dy AS INTEGER
SHARED XBoxDown AS INTEGER, YBoxDown AS INTEGER, XDown AS INTEGER, YWide AS INTEGER
SHARED XBoxTop AS INTEGER, YBoxTop AS INTEGER, XTop AS INTEGER
SHARED WD AS INTEGER, WT AS INTEGER

'check player Down sendback conditions
TmpX = CircleCoordinates(0, 3): TmpY = CircleCoordinates(1, 3)
TmpX1 = CircleCoordinates(0, 2): TmpY1 = CircleCoordinates(1, 2)
TmpX2 = CircleCoordinates(0, 4): TmpY2 = CircleCoordinates(1, 4)
TmpX3 = CircleCoordinates(0, 5): TmpY3 = CircleCoordinates(1, 5)
TmpX4 = CircleCoordinates(0, 1): TmpY4 = CircleCoordinates(1, 1)
IF (TmpX > XBoxDown AND TmpX < XBoxDown + XDown AND TmpY > YBoxDown) OR (TmpX1 > XBoxDown AND TmpX1 < XBoxDown + XDown AND TmpY1 > YBoxDown) OR (TmpX2 > XBoxDown AND TmpX2 < XBoxDown + XDown AND TmpY2 > YBoxDown) THEN
    y = YBoxDown - d - 1
    dy = -dy
    dx = SpeedDXDY(0)
    WD = WD + 1
    SOUND 5000, 1
    'IF y - d + ABS(dy) > YBoxDown THEN y = YBoxDown - d - 5
ELSEIF (TmpX3 > XBoxDown AND TmpX3 < XBoxDown + XDown AND TmpY3 > YBoxDown) OR (TmpX4 > XBoxDown AND TmpX4 < XBoxDown + XDown AND TmpY4 > YBoxDown) THEN
    dy = -dy
    dx = -dx
    WD = WD + 1
    SOUND 5000, 1
    'IF y - d + ABS(dy) > YBoxDown THEN y = YBoxDown - d - 5
END IF


TmpX = CircleCoordinates(0, 7): TmpY = CircleCoordinates(1, 7)
TmpX1 = CircleCoordinates(0, 8): TmpY1 = CircleCoordinates(1, 8)
TmpX2 = CircleCoordinates(0, 6): TmpY2 = CircleCoordinates(1, 6)
TmpX3 = CircleCoordinates(0, 5): TmpY3 = CircleCoordinates(1, 5)
TmpX4 = CircleCoordinates(0, 1): TmpY4 = CircleCoordinates(1, 1)
IF (TmpY < YBoxTop + YWide AND TmpX > XBoxTop AND TmpX < XBoxTop + XTop) OR (TmpY1 < YBoxTop + YWide AND TmpX1 > XBoxTop AND TmpX1 < XBoxTop + XTop) OR (TmpY2 < YBoxTop + YWide AND TmpX2 > XBoxTop AND TmpX2 < XBoxTop + XTop) THEN
    y = YBoxTop + YWide + 1
    SignSave = SGN(dx)
    dy = -dy
    dx = SpeedDXDY(0)
   
    IF RunMode = "Play" THEN
        IF RND > .7 THEN
            IF SGN(dx) <> SignSave THEN dx = -dx
        END IF
    END IF
   
    WT = WT + 1
    SOUND 5000, 1
ELSEIF (TmpY3 < YBoxTop + YWide AND TmpX3 > XBoxTop AND TmpX3 < XBoxTop + XTop) OR (TmpY4 < YBoxTop + YWide AND TmpX4 > XBoxTop AND TmpX4 < XBoxTop + XTop) THEN
    dy = -dy
    dx = -dx
    WT = WT + 1
    SOUND 5000, 1
END IF

'CircleCoordinates(0, z ) = x; CircleCoordinates(1, z ) = y
'             z = 7
'           __.__
'   z = 6 ./     \.z = 8
'        /         \
'z = 5 .|           |.z = 1
'       |           |
'        \.       ./z = 2
'    z = 4 \__.__/
'             z = 3
'
'FOR i = 0 TO 2 * PI STEP PI / 4
'    u = u + 1
'
'    CircleCoordinates(0, u) = r * COS(i) + x1 + r 'x
'    CircleCoordinates(1, u) = r * SIN(i) + y1 + r 'y
'
'NEXT i

END SUB

SUB ShowInfo (FirstCall AS INTEGER)

SHARED RunMode AS STRING, GameDifficulty AS STRING, Rules AS INTEGER
SHARED PlayerTop AS Player, PlayerDown AS Player
SHARED x AS INTEGER, y AS INTEGER, dx AS INTEGER, dy AS INTEGER
SHARED n AS SINGLE, PlayTime AS DOUBLE, StartTime AS DOUBLE
SHARED DCountGame AS INTEGER, TCountGame AS INTEGER
SHARED Server AS INTEGER
SHARED GameD() AS INTEGER, GameT() AS INTEGER
SHARED CheckForTieBreak AS INTEGER
SHARED WD AS INTEGER, WT AS INTEGER

'LINE (0, 16)-(90, 80), 0, BF
LOCATE 2, 5
PRINT "Count"
LOCATE 3, 3
PRINT "1 2 3 4 5"
LOCATE 4, 3'20, 70
COLOR PlayerTop.clr: PRINT USING "# # # # #"; GameT(1); GameT(2); GameT(3); GameT(4); GameT(5)
LOCATE 5, 3 '19, 70
COLOR PlayerDown.clr: PRINT USING "# # # # #"; GameD(1); GameD(2); GameD(3); GameD(4); GameD(5)
COLOR 15

LINE (0, 46)-(90, 47), 15, BF '  ,30 -  ,31
LINE (10, 62)-(90, 62), 15  ' ,46
LINE (27, 31)-(27, 76), 15  ' ,15- ,60
LINE (43, 31)-(43, 76), 15  ' ,15- ,60
LINE (59, 31)-(59, 76), 15  ' ,15- ,60
LINE (75, 31)-(75, 76), 15  ' ,15- ,60

PlayTime = TIMER - StartTime
IF PlayTime < 60 THEN
    ss = INT(PlayTime)
    mm = 0
    hh = 0
ELSEIF PlayTime >= 3600 THEN
    hh = INT(PlayTime / 3600)
    mm = INT((PlayTime - hh * 3600) / 60)
    ss = INT(PlayTime - hh * 3600 - mm * 60)
ELSEIF PlayTime >= 60 THEN
    mm = INT(PlayTime / 60)
    ss = INT(PlayTime - mm * 60)
    hh = 0
END IF

LINE (7, 218)-(97, 243), 12, B  '90-25

IF CheckForTieBreak = 0 THEN
    IF DCountGame = 2 THEN
        LOCATE 15, 3 '34
        COLOR PlayerDown.clr: PRINT "Adv. "; MID$(PlayerDown.FIO, 1, 4)
    ELSEIF TCountGame = 2 THEN
        LOCATE 15, 3 '35
        COLOR PlayerTop.clr: PRINT "Adv. "; MID$(PlayerTop.FIO, 1, 4)
    ELSEIF DCountGame = 1 AND TCountGame = 1 THEN
        LOCATE 15, 3 '34
        PRINT "  Deuce   "
    ELSEIF Server = 0 THEN
        LOCATE 15, 3 '34
        PRINT USING " ## _/ ## "; DCountGame; TCountGame
    ELSEIF Server = 1 THEN
        LOCATE 15, 3 '34
        PRINT USING " ## _/ ## "; TCountGame; DCountGame
    END IF
ELSEIF CheckForTieBreak = 1 THEN
    LOCATE 13, 3
    PRINT "Tiebreak"
    LOCATE 15, 2: COLOR PlayerTop.clr: PRINT MID$(PlayerTop.FIO, 1, 1);
    PRINT USING "_:##"; TCountGame;
    COLOR 15: PRINT " /";
    COLOR PlayerDown.clr: PRINT MID$(PlayerDown.FIO, 1, 1);
    PRINT USING "_:##"; DCountGame
END IF
COLOR 15

IF Server = 0 THEN
    LOCATE 4, 1
    PRINT " "
    LOCATE 5, 1
    PRINT "*"
ELSEIF Server = 1 THEN
    LOCATE 4, 1
    PRINT "*"
    LOCATE 5, 1
    PRINT " "
END IF

'LINE (0, 112)-(96, 160), 0, BF
tmp$ = UCASE$(RTRIM$(PlayerTop.FIO)): z = LEN(tmp$)
LOCATE 8, 1 + INT((12 - z) / 2): COLOR PlayerTop.clr: PRINT tmp$
LOCATE 9, 6: COLOR 15: PRINT "vs"
tmp$ = UCASE$(RTRIM$(PlayerDown.FIO)): z = LEN(tmp$)
LOCATE 10, 1 + INT((12 - z) / 2): COLOR PlayerDown.clr: PRINT tmp$
COLOR 15

'LINE (0, 416)-(88, 448), 0, BF
LOCATE 27, 1                          '} -
PRINT "Match time:"                   '} 뢮 ६, 襤襣 
LOCATE 28, 2                          '} 砫 .
PRINT USING "##_:##_:##"; hh; mm; ss  '} -

'LINE (544, 16)-(640, 111), 0, BF
LOCATE 2, 68: PRINT "Esc - Main"
LOCATE 3, 68: PRINT " menu"
LOCATE 4, 68: PRINT "Space - pause"
LOCATE 5, 68: PRINT " /still"
LOCATE 6, 68: PRINT "Tab - refresh"
LOCATE 7, 68: PRINT " screen"

'LINE (536, 128)-(632, 208), 0, BF
IF RunMode <> "Play2" THEN LOCATE 9, 68: PRINT "Mode: "; RunMode
IF RunMode = "Play2" THEN LOCATE 9, 68: PRINT "Mode: Play 2"
LOCATE 10, 68: PRINT "Level:"
LOCATE 11, 70: PRINT GameDifficulty
LOCATE 12, 68: PRINT "Rules:"
LOCATE 13, 70: PRINT Rules; "set(s)"

LOCATE 20, 68: PRINT "Alt+Q - Exit"

'LINE (536, 416)-(632, 448), 0, BF
LOCATE 27, 68                         '} -
PRINT "System time:"                  '} 뢮 ६, ஥
LOCATE 28, 70                         '} ⮨  樮 ⥬.
PRINT TIME$                           '} -

IF FirstCall = TRUE THEN
    LINE (LEFT - 1, 0)-(LEFT - 1, 480), 15   'Side
    LINE (RIGHT + 1, 0)-(RIGHT + 1, 480), 15 'lines
    'LINE (0, 66)-(LEFT - 1, 66), 15
    'LINE (0, 0)-(LEFT - 2, 480), 1, BF
    PAINT (1, 479), 1, 15
    PAINT (639, 479), 1, 15
   
    LINE (0, 16)-(90, 80), 0, BF
    LINE (0, 112)-(96, 160), 0, BF
    LINE (0, 416)-(88, 448), 0, BF
    LINE (544, 16)-(640, 111), 0, BF
    LINE (536, 128)-(632, 208), 0, BF
    LINE (536, 416)-(632, 448), 0, BF
    IF POINT(8, 219) = 1 THEN LINE (7, 218)-(97, 243), 0, BF '90-25
END IF

END SUB

SUB ShowSprites (Xx AS INTEGER, yy AS INTEGER, First AS INTEGER, ClearScreen AS INTEGER) STATIC

SHARED BallSprite() AS INTEGER, d AS INTEGER, dx AS INTEGER, dy AS INTEGER
SHARED PlTopSprite() AS INTEGER, PlDownSprite() AS INTEGER
SHARED XBoxTop AS INTEGER, YBoxTop AS INTEGER
SHARED XBoxDown AS INTEGER, YBoxDown AS INTEGER

DIM OldX AS INTEGER, OldY AS INTEGER
DIM OldTopX AS INTEGER, OldTopY AS INTEGER
DIM OldDownX AS INTEGER, OldDownY AS INTEGER

'KEY(12) STOP
'KEY(13) STOP

IF ClearScreen THEN
    PUT (OldX, OldY), BallSprite
    PUT (OldDownX, OldDownY), PlDownSprite
    PUT (OldTopX, OldTopY), PlTopSprite
    EXIT SUB
END IF

IF NOT First THEN
    PUT (OldX, OldY), BallSprite, XOR
    PUT (OldDownX, OldDownY), PlDownSprite, XOR
    PUT (OldTopX, OldTopY), PlTopSprite, XOR
END IF
IF Xx < 0 THEN Xx = 0
IF Xx + d > 639 THEN Xx = 639
IF yy < 0 THEN yy = 0
IF yy + d > 479 THEN yy = 479 - d

IF Xx < LEFT THEN 'done
    dx = -dx
    Xx = LEFT + 1
ELSEIF Xx + d > RIGHT THEN
    dx = -dx
    Xx = RIGHT - d - 1
END IF

PUT (Xx, yy), BallSprite
PUT (XBoxDown, YBoxDown), PlDownSprite
PUT (XBoxTop, YBoxTop), PlTopSprite

OldX = Xx
OldY = yy
OldDownX = XBoxDown
OldDownY = YBoxDown
OldTopX = XBoxTop
OldTopY = YBoxTop

'KEY(12) ON
'KEY(13) ON

END SUB

FUNCTION SpeedDXDY% (Direction AS INTEGER)
DIM compair1 AS DOUBLE
DIM Speed AS INTEGER

SHARED RunMode AS STRING, GameDifficulty AS STRING

compair1 = RND

IF Direction = 0 THEN
    Speed = INT(RND * 4 + 3)
ELSEIF Direction = 1 THEN
    Speed = INT(RND * 7 + 2)
    'IF (RunMode = "Play") OR (RunMode = "Watch") THEN
        IF GameDifficulty = "Easy" THEN
            Speed = Speed + 5
        ELSEIF GameDifficulty = "Medium" THEN
            Speed = INT(RND * 15 + 4)  'Speed * 2
        ELSEIF GameDifficulty = "Difficult" THEN
            Speed = INT(RND * 4 + 18)  '20
        END IF
    'END IF

    'Speed = INT(RND * 7 + 2) * 2
ELSE
    Speed = INT(RND * 5 + 3)
    IF RunMode = "Play" THEN
        'Speed = Speed * 2
        IF GameDifficulty = "Easy" THEN
            Speed = Speed + 2
        ELSEIF GameDifficulty = "Medium" THEN
            Speed = Speed * 2 - 1
        ELSEIF GameDifficulty = "Difficult" THEN
            Speed = Speed * 2
        END IF
    END IF
END IF

IF compair1 > .5 THEN
    dx = Speed
ELSE
    dx = -Speed
END IF

SpeedDXDY = dx

END FUNCTION

FUNCTION StringInput$ (Message AS STRING, StrLength AS INTEGER, YRow AS INTEGER, XColumn AS INTEGER)

'|******************************StringInput$********************************|
'|This Function reads a string from the keyboard and prints it on the screen|
'|**************************************************************************|

'Parametrs: StrLength - not more than StrLength number of characters aloud
'in the inputed string; XColumn, YRow - x and y position, where the string
'is printed on the screen; Message - a message which will be printed before
'the string

DIM InputString AS STRING, AddCharacter AS INTEGER

dlMessage = LEN(Message)
LOCATE YRow, XColumn: PRINT SPC(StrLength + dlMessage + 1);
LOCATE YRow, XColumn: PRINT Message
DO
    AddCharacter = TRUE
    dl = LEN(InputString)
    LOCATE YRow, XColumn + dlMessage + dl: PRINT CURSOR
 
    tmp$ = INPUT$(1)
   
    IF tmp$ = CHR$(27) THEN 'Esc
        InputString = ""
        EXIT DO
    ELSEIF tmp$ = CHR$(13) THEN 'Enter
        IF dl >= 1 THEN EXIT DO
    ELSEIF tmp$ = CHR$(8) THEN 'BackSpace
        IF dl >= 1 THEN InputString = LEFT$(InputString, dl - 1)
    END IF
 
    FOR I = 1 TO 6 '1 to 4
        IF I = 1 THEN
            jMin = 32: jMax = 41
        ELSEIF I = 2 THEN
            jMin = 48: jMax = 57
        ELSEIF I = 3 THEN
            jMin = 65: jMax = 90
        ELSEIF I = 4 THEN
            jMin = 97: jMax = 122
        ELSEIF I = 5 THEN
            jMin = 128: jMax = 175
        ELSEIF I = 6 THEN
            jMin = 224: jMax = 241
        END IF
        FOR j = jMin TO jMax
            IF tmp$ = CHR$(j) THEN
                AddCharacter = TRUE: EXIT FOR
            ELSE
                AddCharacter = FALSE
            END IF
        NEXT j
        IF AddCharacter = TRUE THEN EXIT FOR
    NEXT I
   
    IF dl = StrLength THEN 'too many characters
        LOCATE YRow - 1, (XColumn + INT((dlMessage + 8) / 2)) - 12
        PRINT "Only"; StrLength; "characters allowed" '25
        AddCharacter = FALSE
    END IF

    IF AddCharacter = TRUE THEN  'tmp$ <> CHR$(8) AND tmp$ <> CHR$(27) AND tmp$ <> CHR$(13) AND
        InputString = InputString + tmp$
    END IF
 
    LOCATE YRow, XColumn: PRINT SPC(StrLength + dlMessage + 1);
    LOCATE YRow, XColumn: PRINT Message; InputString
LOOP
'LOCATE YRow, XColumn: PRINT InputString

StringInput$ = InputString

END FUNCTION

SUB Tiebreak (Pl AS INTEGER) STATIC

DIM TiebreakCount AS INTEGER

SHARED Rules AS INTEGER
SHARED TCountGame AS INTEGER, DCountGame AS INTEGER
SHARED GameD() AS INTEGER, GameT() AS INTEGER
SHARED SetD AS INTEGER, SetT AS INTEGER, CurrentSet AS INTEGER
SHARED CheckForTieBreak AS INTEGER, Server AS INTEGER

IF Pl = 0 THEN
    DCountGame = DCountGame + 1
ELSEIF Pl = 1 THEN
    TCountGame = TCountGame + 1
'ELSEIF Pl = 2 THEN
'    TiebreakCount = 1
END IF

IF TiebreakCount MOD 2 = 1 THEN
    IF Server = 1 THEN
        Server = 0
    ELSEIF Server = 0 THEN
        Server = 1
    END IF
END IF

TiebreakCount = TiebreakCount + 1

IF (DCountGame > 6) AND (DCountGame - TCountGame >= 2) THEN
    GameD(0) = GameD(0) + 1
   
    SetD = SetD + 1
    GameD(CurrentSet) = GameD(0)
    GameT(CurrentSet) = GameT(0)
   
    CheckForTieBreak = 0
    TiebreakCount = 0
    TCountGame = 0
    DCountGame = 0
   
    GameD(0) = 0
    GameT(0) = 0
   
    LOCATE 13, 3
    PRINT "        "
    LINE (16, 192)-(80, 208), 1, BF

    LINE (7, 218)-(97, 243), 0, BF  '90-25
    IF SetD = Rules THEN 'checking for gameover
        GameOver 0
    ELSEIF SetT = Rules THEN
        GameOver 1
    END IF
ELSEIF (TCountGame > 6) AND (TCountGame - DCountGame >= 2) THEN
    GameT(0) = GameT(0) + 1

    SetT = SetT + 1
    GameD(CurrentSet) = GameD(0)
    GameT(CurrentSet) = GameT(0)
   
    CheckForTieBreak = 0
    TiebreakCount = 0
    TCountGame = 0
    DCountGame = 0
   
    GameD(0) = 0
    GameT(0) = 0
   
    LOCATE 13, 3
    PRINT "        "
    LINE (16, 192)-(80, 208), 1, BF

    LINE (7, 218)-(97, 243), 0, BF  '90-25
    IF SetD = Rules THEN 'checking for gameover
        GameOver 0
    ELSEIF SetT = Rules THEN
        GameOver 1
    END IF
END IF

END SUB

